Makefile 34.9 KB
Newer Older
1
#
2 3 4
# This file is part of the flashrom project.
#
# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
5
# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
6 7 8 9 10 11 12 13 14 15 16 17 18
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
19
#
20

21
PROGRAM = flashrom
Ronald G. Minnich's avatar
Ronald G. Minnich committed
22

23 24 25 26 27 28
###############################################################################
# Defaults for the toolchain.

# If you want to cross-compile, just run e.g.
# make CC=i586-pc-msdosdjgpp-gcc
# You may have to specify STRIP/AR/RANLIB as well.
29 30 31
#
# Note for anyone editing this Makefile: gnumake will happily ignore any
# changes in this Makefile to variables set on the command line.
32
STRIP   ?= strip
33
INSTALL = install
34
DIFF    = diff
35
PREFIX  ?= /usr/local
36
MANDIR  ?= $(PREFIX)/share/man
37
CFLAGS  ?= -Os -Wall -Wshadow
38
EXPORTDIR ?= .
39
RANLIB  ?= ranlib
40 41
PKG_CONFIG ?= pkg-config
BUILD_DETAILS_FILE ?= build_details.txt
42

43 44 45 46 47 48 49 50 51 52 53 54
# The following parameter changes the default programmer that will be used if there is no -p/--programmer
# argument given when running flashrom. The predefined setting does not enable any default so that every
# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
# system attached to an external programmer while the default programmer is set to the internal programmer, and
# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
# values are those specified in enum programmer in programmer.h (which depend on other CONFIG_* options
# evaluated below, namely those that enable/disable the various programmers).
# Compilation will fail for unspecified values.
CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID
55 56 57 58 59
# The following adds a default parameter for the default programmer set above (only).
CONFIG_DEFAULT_PROGRAMMER_ARGS ?= ''
# Example: compiling with
#   make CONFIG_DEFAULT_PROGRAMMER=PROGRAMMER_SERPROG CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
60

61 62
# If your compiler spits out excessive warnings, run make WARNERROR=no
# You shouldn't have to change this flag.
63 64 65 66 67 68
WARNERROR ?= yes

ifeq ($(WARNERROR), yes)
CFLAGS += -Werror
endif

69
ifdef LIBS_BASE
70
CPPFLAGS += -I$(LIBS_BASE)/include
71 72 73
LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
endif
74

75 76
dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(1) ; }' >&2;  { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
77
###############################################################################
78 79 80 81
# General OS-specific settings.
# 1. Prepare for later by gathering information about host and target OS
# 2. Set compiler flags and parameters according to OSes
# 3. Likewise verify user-supplied CONFIG_* variables.
82

83
# HOST_OS is only used to work around local toolchain issues.
84
HOST_OS ?= $(shell uname)
85 86 87 88 89
ifeq ($(HOST_OS), MINGW32_NT-5.1)
# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
CC = gcc
endif
ifneq ($(HOST_OS), SunOS)
90 91
STRIP_ARGS = -s
endif
92

93
# Determine the destination OS.
94 95 96
# IMPORTANT: The following line must be placed before TARGET_OS is ever used
# (of course), but should come after any lines setting CC because the line
# below uses CC itself.
97
override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
98 99

ifeq ($(TARGET_OS), Darwin)
100
CPPFLAGS += -I/opt/local/include -I/usr/local/include
101
LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauer's avatar
Stefan Reinauer committed
102
endif
103

104
ifeq ($(TARGET_OS), FreeBSD)
105
CPPFLAGS += -I/usr/local/include
106 107
LDFLAGS += -L/usr/local/lib
endif
108

109
ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
110 111 112
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
endif
113

Stefan Tauner's avatar
Stefan Tauner committed
114 115 116 117 118 119
ifeq ($(TARGET_OS), NetBSD)
CPPFLAGS += -I/usr/pkg/include
LDFLAGS += -L/usr/pkg/lib
endif

ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner's avatar
Stefan Tauner committed
120 121
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
Stefan Tauner's avatar
Stefan Tauner committed
122 123
endif

124
ifeq ($(TARGET_OS), DOS)
125
EXEC_SUFFIX := .exe
126
# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
127
CFLAGS += -Wno-format
Stefan Tauner's avatar
Stefan Tauner committed
128
LIBS += -lgetopt
129
# Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
130 131 132 133 134 135 136 137 138 139
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
140 141 142 143 144
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
145
# Dediprog, USB-Blaster, PICkit2 and FT2232 are not supported under DOS (missing USB support).
146 147 148 149 150 151 152 153 154 155
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
156 157 158 159 160
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
161 162 163 164 165
ifeq ($(CONFIG_PICKIT2_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
else
override CONFIG_PICKIT2_SPI = no
endif
166
endif
167

168 169 170
# FIXME: Should we check for Cygwin/MSVC as well?
ifeq ($(TARGET_OS), MinGW)
EXEC_SUFFIX := .exe
171
# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
172
FLASHROM_CFLAGS += -Dffs=__builtin_ffs
173 174 175
# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
# for MinGW. See http://sourceforge.net/apps/trac/mingw-w64/wiki/printf%20and%20scanf%20family */
FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209
# libusb-win32/libftdi stuff is usually installed in /usr/local.
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
ifeq ($(CONFIG_INTERNAL), yes)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
else
override CONFIG_INTERNAL = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_GFXNVIDIA), yes)
UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
else
override CONFIG_GFXNVIDIA = no
endif
ifeq ($(CONFIG_SATASII), yes)
UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
else
override CONFIG_SATASII = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
210 211 212 213 214
ifeq ($(CONFIG_ATAVIA), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
else
override CONFIG_ATAVIA = no
endif
Kyösti Mälkki's avatar
Kyösti Mälkki committed
215 216 217 218 219
ifeq ($(CONFIG_IT8212), yes)
UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
else
override CONFIG_IT8212 = no
endif
220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239
ifeq ($(CONFIG_DRKAISER), yes)
UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
else
override CONFIG_DRKAISER = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_NICINTEL), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
else
override CONFIG_NICINTEL = no
endif
240 241 242 243 244
ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
else
override CONFIG_NICINTEL_EEPROM = no
endif
245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261
ifeq ($(CONFIG_NICINTEL_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
else
override CONFIG_NICINTEL_SPI = no
endif
ifeq ($(CONFIG_OGP_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
else
override CONFIG_OGP_SPI = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

262
ifeq ($(TARGET_OS), libpayload)
263 264 265 266
ifeq ($(MAKECMDGOALS),)
.DEFAULT_GOAL := libflashrom.a
$(info Setting default goal to libflashrom.a)
endif
267
FLASHROM_CFLAGS += -DSTANDALONE
268 269 270 271 272
ifeq ($(CONFIG_DUMMY), yes)
UNSUPPORTED_FEATURES += CONFIG_DUMMY=yes
else
override CONFIG_DUMMY = no
endif
273
# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
274 275 276 277 278 279 280 281 282 283
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
284 285 286 287 288
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
289
# Dediprog, USB-Blaster, PICkit2 and FT2232 are not supported with libpayload (missing libusb support)
290 291 292 293 294 295 296 297 298 299
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
300 301 302 303 304
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
305 306 307 308 309
ifeq ($(CONFIG_PICKIT2_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
else
override CONFIG_PICKIT2_SPI = no
endif
310 311
endif

312 313 314 315 316 317
ifneq ($(TARGET_OS), Linux)
ifeq ($(CONFIG_LINUX_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
else
override CONFIG_LINUX_SPI = no
endif
318 319 320 321 322
ifeq ($(CONFIG_MSTARDDC_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
else
override CONFIG_MSTARDDC_SPI = no
endif
323 324
endif

325 326 327 328
###############################################################################
# General architecture-specific settings.
# Like above for the OS, below we verify user-supplied options depending on the target architecture.

329 330 331
# Determine the destination processor architecture.
# IMPORTANT: The following line must be placed before ARCH is ever used
# (of course), but should come after any lines setting CC because the line
332
# below uses CC itself.
333
override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
334

Stefan Tauner's avatar
Stefan Tauner committed
335
# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
336 337
# Right now this means the drivers below only work on x86.
ifneq ($(ARCH), x86)
338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

370 371 372
###############################################################################
# Flash chip drivers and bus support infrastructure.

Stefan Tauner's avatar
Stefan Tauner committed
373
CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
374
	sst28sf040.o 82802ab.o \
375
	sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
376
	opaque.o sfdp.o en29lv640b.o at45db.o
377

378 379
###############################################################################
# Library code.
380

Stefan Tauner's avatar
Stefan Tauner committed
381
LIB_OBJS = layout.o flashrom.o udelay.o programmer.o helpers.o
382

383 384
###############################################################################
# Frontend related stuff.
385

386
CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
387

Stefan Tauner's avatar
Stefan Tauner committed
388
# Set the flashrom version string from the highest revision number of the checked out flashrom files.
389 390
# Note to packagers: Any tree exported with "make export" or "make tarball"
# will not require subversion. The downloadable snapshots are already exported.
Stefan Tauner's avatar
Stefan Tauner committed
391
SVNVERSION := $(shell ./util/getrevision.sh -u 2>/dev/null )
392

393
RELEASE := 0.9.8
Stefan Tauner's avatar
Stefan Tauner committed
394
VERSION := $(RELEASE)-$(SVNVERSION)
395
RELEASENAME ?= $(VERSION)
396 397

SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'
398

Stefan Tauner's avatar
Stefan Tauner committed
399 400
# Inform user if there is no meaningful version string. If there is version information from a VCS print
# something anyway because $(info...) will print a line break in any case which would look suspicious.
401 402 403
# The && between the echos is a workaround for old versions of GNU make that issue the error "unterminated
# variable reference" if a semicolon is used instead.
$(info $(shell ./util/getrevision.sh -c 2>/dev/null || echo "Files don't seem to be under version control." && \
Stefan Tauner's avatar
Stefan Tauner committed
404 405
	echo "Replacing all version templates with $(VERSION)." ))

406 407 408
###############################################################################
# Default settings of CONFIG_* variables.

409 410 411
# Always enable internal/onboard support for now.
CONFIG_INTERNAL ?= yes

Stefan Tauner's avatar
Stefan Tauner committed
412
# Always enable serprog for now.
413 414
CONFIG_SERPROG ?= yes

415 416 417
# RayeR SPIPGM hardware support
CONFIG_RAYER_SPI ?= yes

418 419 420
# PonyProg2000 SPI hardware support
CONFIG_PONY_SPI ?= yes

421 422 423
# Always enable 3Com NICs for now.
CONFIG_NIC3COM ?= yes

424 425
# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
CONFIG_GFXNVIDIA ?= yes
426

427 428 429
# Always enable SiI SATA controllers for now.
CONFIG_SATASII ?= yes

430 431 432 433
# Highpoint (HPT) ATA/RAID controller support.
# IMPORTANT: This code is not yet working!
CONFIG_ATAHPT ?= no

434 435 436
# VIA VT6421A LPC memory support
CONFIG_ATAVIA ?= yes

437
# Always enable FT2232 SPI dongles for now.
438
CONFIG_FT2232_SPI ?= yes
439

440 441 442
# Always enable Altera USB-Blaster dongles for now.
CONFIG_USBBLASTER_SPI ?= yes

443 444 445
# MSTAR DDC support needs more tests/reviews/cleanups.
CONFIG_MSTARDDC_SPI ?= no

446 447 448
# Always enable PICkit2 SPI dongles for now.
CONFIG_PICKIT2_SPI ?= yes

449 450 451 452 453
# Always enable dummy tracing for now.
CONFIG_DUMMY ?= yes

# Always enable Dr. Kaiser for now.
CONFIG_DRKAISER ?= yes
454

455 456 457
# Always enable Realtek NICs for now.
CONFIG_NICREALTEK ?= yes

458 459 460
# Disable National Semiconductor NICs until support is complete and tested.
CONFIG_NICNATSEMI ?= no

461 462 463
# Always enable Intel NICs for now.
CONFIG_NICINTEL ?= yes

464 465 466
# Always enable SPI on Intel NICs for now.
CONFIG_NICINTEL_SPI ?= yes

467 468 469
# Always enable EEPROM on Intel NICs for now.
CONFIG_NICINTEL_EEPROM ?= yes

470 471 472
# Always enable SPI on OGP cards for now.
CONFIG_OGP_SPI ?= yes

473
# Always enable Bus Pirate SPI for now.
474
CONFIG_BUSPIRATE_SPI ?= yes
475

476 477 478
# Disable Dediprog SF100 until support is complete and tested.
CONFIG_DEDIPROG ?= no

479 480 481
# Always enable Marvell SATA controllers for now.
CONFIG_SATAMV ?= yes

482 483 484
# Enable Linux spidev interface by default. We disable it on non-Linux targets.
CONFIG_LINUX_SPI ?= yes

Kyösti Mälkki's avatar
Kyösti Mälkki committed
485 486 487
# Always enable ITE IT8212F PATA controllers for now.
CONFIG_IT8212 ?= yes

488
# Disable wiki printing by default. It is only useful if you have wiki access.
489
CONFIG_PRINT_WIKI ?= no
490

491 492 493 494 495 496 497
# Enable all features if CONFIG_EVERYTHING=yes is given
ifeq ($(CONFIG_EVERYTHING), yes)
$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
	$(if $(filter no, $($(var))),\
		$(eval $(var)=yes)))
endif

498 499 500 501
# Bitbanging SPI infrastructure, default off unless needed.
ifeq ($(CONFIG_RAYER_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
502 503 504
ifeq ($(CONFIG_PONY_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
505 506 507 508 509 510
ifeq ($(CONFIG_INTERNAL), yes)
override CONFIG_BITBANG_SPI = yes
else
ifeq ($(CONFIG_NICINTEL_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
511 512 513
ifeq ($(CONFIG_OGP_SPI), yes)
override CONFIG_BITBANG_SPI = yes
else
514 515 516 517
CONFIG_BITBANG_SPI ?= no
endif
endif
endif
518
endif
519
endif
520

Sean Nelson's avatar
Sean Nelson committed
521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537
###############################################################################
# Handle CONFIG_* variables that depend on others set (and verified) above.

# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
ifeq ($(TARGET_OS), libpayload)
ifeq ($(CONFIG_INTERNAL), yes)
ifeq ($(CONFIG_INTERNAL_DMI), no)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
else
override CONFIG_INTERNAL_DMI = yes
endif
endif
endif

# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
CONFIG_INTERNAL_DMI ?= yes

538 539
###############################################################################
# Programmer drivers and programmer support infrastructure.
540
# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
541

542
FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER=$(CONFIG_DEFAULT_PROGRAMMER)'
543
FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
544

545
ifeq ($(CONFIG_INTERNAL), yes)
546
FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson's avatar
Sean Nelson committed
547
PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
548
ifeq ($(ARCH), x86)
549
PROGRAMMER_OBJS += it87spi.o it85spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Sean Nelson's avatar
Sean Nelson committed
550 551 552 553
PROGRAMMER_OBJS += ichspi.o ich_descriptors.o dmi.o
ifeq ($(CONFIG_INTERNAL_DMI), yes)
FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
endif
554 555
else
endif
556 557 558
NEED_PCI := yes
endif

559
ifeq ($(CONFIG_SERPROG), yes)
560
FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
561
PROGRAMMER_OBJS += serprog.o
562 563
NEED_SERIAL := yes
NEED_NET := yes
564
endif
565

566 567 568 569 570 571 572
ifeq ($(CONFIG_RAYER_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
PROGRAMMER_OBJS += rayer_spi.o
# Actually, NEED_PCI is wrong. NEED_IOPORT_ACCESS would be more correct.
NEED_PCI := yes
endif

573 574 575 576 577 578
ifeq ($(CONFIG_PONY_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
PROGRAMMER_OBJS += pony_spi.o
NEED_SERIAL := yes
endif

579
ifeq ($(CONFIG_BITBANG_SPI), yes)
580
FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
581
PROGRAMMER_OBJS += bitbang_spi.o
582 583
endif

584
ifeq ($(CONFIG_NIC3COM), yes)
585
FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
586
PROGRAMMER_OBJS += nic3com.o
587
NEED_PCI := yes
588
endif
589

590
ifeq ($(CONFIG_GFXNVIDIA), yes)
591
FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
592
PROGRAMMER_OBJS += gfxnvidia.o
593
NEED_PCI := yes
594 595
endif

596
ifeq ($(CONFIG_SATASII), yes)
597
FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
598
PROGRAMMER_OBJS += satasii.o
599
NEED_PCI := yes
600 601
endif

602
ifeq ($(CONFIG_ATAHPT), yes)
603
FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
604 605 606 607
PROGRAMMER_OBJS += atahpt.o
NEED_PCI := yes
endif

608 609 610 611 612 613
ifeq ($(CONFIG_ATAVIA), yes)
FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
PROGRAMMER_OBJS += atavia.o
NEED_PCI := yes
endif

Kyösti Mälkki's avatar
Kyösti Mälkki committed
614 615 616 617 618 619
ifeq ($(CONFIG_IT8212), yes)
FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
PROGRAMMER_OBJS += it8212.o
NEED_PCI := yes
endif

620
ifeq ($(CONFIG_FT2232_SPI), yes)
621
# This is a totally ugly hack.
622
FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
623 624 625 626 627 628
NEED_FTDI := yes
PROGRAMMER_OBJS += ft2232_spi.o
endif

ifeq ($(CONFIG_USBBLASTER_SPI), yes)
# This is a totally ugly hack.
629
FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
630 631 632 633
NEED_FTDI := yes
PROGRAMMER_OBJS += usbblaster_spi.o
endif

634 635 636 637 638 639
ifeq ($(CONFIG_PICKIT2_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
PROGRAMMER_OBJS += pickit2_spi.o
NEED_USB := yes
endif

640
ifeq ($(NEED_FTDI), yes)
641 642 643
FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
Alexandru Gagniuc's avatar
Alexandru Gagniuc committed
644
FEATURE_CFLAGS += $(FTDI_INCLUDES)
645
FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
646 647
# We can't set NEED_USB here because that would transform libftdi auto-enabling
# into a hard requirement for libusb, defeating the purpose of auto-enabling.
648 649 650
endif

ifeq ($(CONFIG_DUMMY), yes)
651
FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
652
PROGRAMMER_OBJS += dummyflasher.o
653 654 655
endif

ifeq ($(CONFIG_DRKAISER), yes)
656
FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
657
PROGRAMMER_OBJS += drkaiser.o
658
NEED_PCI := yes
659
endif
660

661
ifeq ($(CONFIG_NICREALTEK), yes)
662
FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
663 664 665 666
PROGRAMMER_OBJS += nicrealtek.o
NEED_PCI := yes
endif

667 668 669 670 671 672
ifeq ($(CONFIG_NICNATSEMI), yes)
FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
PROGRAMMER_OBJS += nicnatsemi.o
NEED_PCI := yes
endif

673 674 675 676 677 678
ifeq ($(CONFIG_NICINTEL), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
PROGRAMMER_OBJS += nicintel.o
NEED_PCI := yes
endif

679 680 681 682 683 684
ifeq ($(CONFIG_NICINTEL_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
PROGRAMMER_OBJS += nicintel_spi.o
NEED_PCI := yes
endif

685 686 687 688 689 690
ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
PROGRAMMER_OBJS += nicintel_eeprom.o
NEED_PCI := yes
endif

691 692 693 694 695 696
ifeq ($(CONFIG_OGP_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
PROGRAMMER_OBJS += ogp_spi.o
NEED_PCI := yes
endif

697 698
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
699
PROGRAMMER_OBJS += buspirate_spi.o
700
NEED_SERIAL := yes
701 702
endif

703
ifeq ($(CONFIG_DEDIPROG), yes)
704
FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
705
PROGRAMMER_OBJS += dediprog.o
706
NEED_USB := yes
707 708
endif

709 710 711 712 713 714
ifeq ($(CONFIG_SATAMV), yes)
FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
PROGRAMMER_OBJS += satamv.o
NEED_PCI := yes
endif

715
ifeq ($(CONFIG_LINUX_SPI), yes)
716
# This is a totally ugly hack.
717
FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
718 719 720
PROGRAMMER_OBJS += linux_spi.o
endif

721 722
ifeq ($(CONFIG_MSTARDDC_SPI), yes)
# This is a totally ugly hack.
723
FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
724 725 726 727
NEED_LINUX_I2C := yes
PROGRAMMER_OBJS += mstarddc_spi.o
endif

728
ifeq ($(NEED_SERIAL), yes)
729
LIB_OBJS += serial.o
730
endif
731

732
ifeq ($(NEED_NET), yes)
733
ifeq ($(TARGET_OS), SunOS)
734 735
LIBS += -lsocket
endif
736 737 738
endif

ifeq ($(NEED_PCI), yes)
739
CHECK_LIBPCI = yes
740
FEATURE_CFLAGS += -D'NEED_PCI=1'
741
FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
742

743
PROGRAMMER_OBJS += pcidev.o physmap.o hwaccess.o
744
ifeq ($(TARGET_OS), NetBSD)
745
# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
746
PCILIBS += -lpciutils -lpci
747
# For (i386|x86_64)_iopl(2).
748
PCILIBS += -l$(shell uname -p)
749
else
750

751
PCILIBS += -lpci
752

753
ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
754
# For (i386|amd64)_iopl(2).
755
PCILIBS += -l$(shell uname -m)
756 757 758
else
ifeq ($(TARGET_OS), Darwin)
# DirectHW framework can be found in the DirectHW library.
759
PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfinger's avatar
Carl-Daniel Hailfinger committed
760
endif
761
endif
Jonathan A. Kollasch's avatar
Jonathan A. Kollasch committed
762
endif
763 764
endif

765 766 767
ifeq ($(NEED_USB), yes)
CHECK_LIBUSB0 = yes
FEATURE_CFLAGS += -D'NEED_USB=1'
768
USBLIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libusb || printf "%s" "-lusb")
769 770
endif

771
ifeq ($(CONFIG_PRINT_WIKI), yes)
772
FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
773
CLI_OBJS += print_wiki.o
774 775
endif

776
FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
777

778
# We could use PULLED_IN_LIBS, but that would be ugly.
779
FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
780

781
LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
782
OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
783

784
all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
785 786 787 788
ifeq ($(ARCH), x86)
	@+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
endif

789
$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
790
	$(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS)
791

792 793 794 795
libflashrom.a: $(LIBFLASHROM_OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

796 797 798 799
# TAROPTIONS reduces information leakage from the packager's system.
# If other tar programs support command line arguments for setting uid/gid of
# stored files, they can be handled here as well.
TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
800

801
%.o: %.c .features
802
	$(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SVNDEF) -o $@ -c $<
803

804 805
# Make sure to add all names of generated binaries here.
# This includes all frontends and libflashrom.
806
# We don't use EXEC_SUFFIX here because we want to clean everything.
807
clean:
808
	rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(BUILD_DETAILS_FILE)
809
	@+$(MAKE) -C util/ich_descriptors_tool/ clean
810 811

distclean: clean
812
	rm -f .features .libdeps
813

814 815
strip: $(PROGRAM)$(EXEC_SUFFIX)
	$(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
816

817 818 819 820 821 822 823 824 825 826 827 828 829
# to define test programs we use verbatim variables, which get exported
# to environment variables and are referenced with $$<varname> later

define COMPILER_TEST
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export COMPILER_TEST

830
compiler: featuresavailable
831
	@printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
832
	@echo "$$COMPILER_TEST" > .test.c
833 834 835
	@{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
		echo "found." || { echo "not found."; \
		rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
836
	@rm -f .test.c .test$(EXEC_SUFFIX)
837
	@printf "Target arch is "
838
	@# FreeBSD wc will output extraneous whitespace.
839
	@echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' ||	\
840 841
		( echo "unknown. Aborting."; exit 1)
	@printf "%s\n" '$(ARCH)'
842 843 844 845 846
	@printf "Target OS is "
	@# FreeBSD wc will output extraneous whitespace.
	@echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' ||	\
		( echo "unknown. Aborting."; exit 1)
	@printf "%s\n" '$(TARGET_OS)'
847 848 849 850 851
ifeq ($(TARGET_OS), libpayload)
	@$(CC) --version 2>&1 | grep -q coreboot || \
		( echo "Warning: It seems you are not using coreboot's reference compiler."; \
		  echo "This might work but usually does not, please beware." )
endif
852

853 854 855
define LIBPCI_TEST
/* Avoid a failing test due to libpci header symbol shadowing breakage */
#define index shadow_workaround_index
Stefan Tauner's avatar
Stefan Tauner committed
856
#if !defined __NetBSD__
857
#include <pci/pci.h>
Stefan Tauner's avatar
Stefan Tauner committed
858 859 860
#else
#include <pciutils/pci.h>
#endif
861 862 863 864 865 866 867 868 869 870 871
struct pci_access *pacc;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	pacc = pci_alloc();
	return 0;
}
endef
export LIBPCI_TEST

872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892
define PCI_GET_DEV_TEST
/* Avoid a failing test due to libpci header symbol shadowing breakage */
#define index shadow_workaround_index
#if !defined __NetBSD__
#include <pci/pci.h>
#else
#include <pciutils/pci.h>
#endif
struct pci_access *pacc;
struct pci_dev *dev = {0};
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	pacc = pci_alloc();
	dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
	return 0;
}
endef
export PCI_GET_DEV_TEST

893
define LIBUSB0_TEST
894 895 896 897
#include "platform.h"
#if IS_WINDOWS
#include <lusb0_usb.h>
#else
898
#include <usb.h>
899
#endif
900 901 902 903 904 905 906 907 908 909 910 911
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	usb_init();
	return 0;
}
endef
export LIBUSB0_TEST

hwlibs: compiler
	@printf "" > .libdeps
912
ifeq ($(CHECK_LIBPCI), yes)
913
	@printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
914
	@echo "$$LIBPCI_TEST" > .test.c
915 916 917
	@{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
		echo "found." || { echo "not found."; echo;			\
		echo "Please install libpci headers."; \
918
		echo "See README for more information."; echo;			\
919 920
		rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
	@printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
921
	@echo "$$PCI_GET_DEV_TEST" > .test.c
922
	@ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
923
		( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) ||	\
924 925 926 927 928 929 930
		( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
	@printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
	@{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
		echo "yes." || { echo "no.";							\
		printf "Checking if libz+libpci are present and sufficient..." ; \
		{ $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
		echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo;	\
931
		echo "Please install libpci (package pciutils) and/or libz.";			\
932
		echo "See README for more information."; echo;				\
933
		rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
934
	@rm -f .test.c .test.o .test$(EXEC_SUFFIX)
935 936
endif
ifeq ($(CHECK_LIBUSB0), yes)
937
	@printf "Checking for libusb-0.1/libusb-compat headers... " | tee -a $(BUILD_DETAILS_FILE)
938
	@echo "$$LIBUSB0_TEST" > .test.c
939 940
	@{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
		echo "found." || { echo "not found."; echo;				\
941 942
		echo "Please install libusb-0.1 headers or libusb-compat headers.";	\
		echo "See README for more information."; echo;				\
943 944 945 946
		rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
	@printf "Checking if libusb-0.1 is usable... " | tee -a $(BUILD_DETAILS_FILE)
	@{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS) >&2 && \
		echo "yes." || { echo "no.";						\
947 948
		echo "Please install libusb-0.1 or libusb-compat.";			\
		echo "See README for more information."; echo;				\
949
		rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
950
	@rm -f .test.c .test.o .test$(EXEC_SUFFIX)
951
endif
952

953 954
.features: features

955 956 957
# If a user does not explicitly request a non-working feature, we should
# silently disable it. However, if a non-working (does not compile) feature
# is explicitly requested, we should bail out with a descriptive error message.
958
# We also have to check that at least one programmer driver is enabled.
959
featuresavailable:
960 961 962 963 964
ifeq ($(PROGRAMMER_OBJS),)
	@echo "You have to enable at least one programmer driver!"
	@false
endif
ifneq ($(UNSUPPORTED_FEATURES), )
965 966 967 968
	@echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
	@false
endif

969
define FTDI_TEST
970
#include <stdlib.h>
971 972 973 974 975 976 977 978 979 980 981
#include <ftdi.h>
struct ftdi_context *ftdic = NULL;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return ftdi_init(ftdic);
}
endef
export FTDI_TEST

982 983 984 985 986 987
define FTDI_232H_TEST
#include <ftdi.h>
enum ftdi_chip_type type = TYPE_232H;
endef
export FTDI_232H_TEST

988 989 990 991 992 993 994 995 996 997 998 999 1000
define UTSNAME_TEST
#include <sys/utsname.h>
struct utsname osinfo;
int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	uname (&osinfo);
	return 0;
}
endef
export UTSNAME_TEST

1001 1002 1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013
define LINUX_SPI_TEST
#include <linux/types.h>
#include <linux/spi/spidev.h>

int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export LINUX_SPI_TEST

1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026
define LINUX_I2C_TEST
#include <linux/i2c-dev.h>
#include <linux/i2c.h>

int main(int argc, char **argv)
{
	(void) argc;
	(void) argv;
	return 0;
}
endef
export LINUX_I2C_TEST

1027 1028
features: compiler
	@echo "FEATURES := yes" > .features.tmp
1029
ifeq ($(NEED_FTDI), yes)
1030
	@printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
1031
	@echo "$$FTDI_TEST" > .featuretest.c
1032 1033 1034 1035 1036 1037 1038 1039 1040 1041
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
	(	echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
		printf "Checking for FT232H support in libftdi... " ; \
		echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
		{ $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
			( echo "found."; echo "FT232H := yes" >> .features.tmp ) ||	\
			( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
	) || \
	( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
	2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1042 1043
endif
ifeq ($(CONFIG_LINUX_SPI), yes)
1044
	@printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1045
	@echo "$$LINUX_SPI_TEST" > .featuretest.c
1046
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1047
		( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) ||	\
1048 1049
		( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
		2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1050 1051
endif
ifeq ($(NEED_LINUX_I2C), yes)
1052
	@printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1053
	@echo "$$LINUX_I2C_TEST" > .featuretest.c
1054
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1055
		( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) ||	\
1056 1057
		( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
		2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1058
endif
1059
	@printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
1060
	@echo "$$UTSNAME_TEST" > .featuretest.c
1061
	@ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1062
		( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) ||	\
1063
		( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1064
	@$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1065
	@rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
1066

1067
$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner's avatar
Stefan Tauner committed
1068
	@sed -e '1 s#".*".*#"$(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)" "$(VERSION)"#' <$< >$@
1069 1070

install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
1071
	mkdir -p $(DESTDIR)$(PREFIX)/sbin
1072
	mkdir -p $(DESTDIR)$(MANDIR)/man8
1073
	$(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
1074
	$(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
1075

1076
export: $(PROGRAM).8
1077 1078 1079
	@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@svn export -r BASE . $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@sed "s/^SVNVERSION.*/SVNVERSION := $(SVNVERSION)/" Makefile >$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile
1080
	@cp $(PROGRAM).8 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$(PROGRAM).8"
1081 1082
	@LC_ALL=C svn log >$(EXPORTDIR)/flashrom-$(RELEASENAME)/ChangeLog
	@echo Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/
1083 1084

tarball: export
1085 1086 1087
	@tar cjf $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2 -C $(EXPORTDIR)/ $(TAROPTIONS) flashrom-$(RELEASENAME)/
	@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
	@echo Created $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2
1088

1089
djgpp-dos: clean
1090 1091 1092
	make CC=i586-pc-msdosdjgpp-gcc STRIP=i586-pc-msdosdjgpp-strip
libpayload: clean
	make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
1093

1094
.PHONY: all install clean distclean compiler hwlibs features export tarball djgpp-dos featuresavailable libpayload
1095

1096
-include $(OBJS:.o=.d)